import { createReducer } from '../utils/reducer'
import { has, map, isEqual } from 'lodash'

const initialState = {
    containers: []
}

/**
 * 
 * @param {*} containers 
 * @param {*} action 
 */
const setContainers = (containers, action) => {
    // single instance
    if (has(action.payload, 'container')) {
        return map(containers, c => {
            return isEqual(c.id, action.payload.container.id) ? action.payload.container : c
        })
    }

    // multiple instances
    if (has(action.payload, 'containers')) {
        return action.payload.containers
    }

    return containers
}

/**
 * 
 */
const containersReducer = createReducer(initialState.containers, {
    'REQUEST_OK': setContainers
})

/**
 * 
 */
export const containers = (state = initialState, action) => {
    return containersReducer(state.containers, action)
}