import { createStore, combineReducers, applyMiddleware } from 'redux'
import { routerReducer, routerMiddleware } from 'react-router-redux'
import createBrowserHistory from 'history/createBrowserHistory'
import ThunkMiddleware from  'redux-thunk'
import LoggerMiddleware from 'redux-logger'

import { auth } from './auth'
import { spinner } from './spinner'
import { notification } from './notification'
import { containers } from './containers'
import { task } from './task'
import { requests } from './requests'

const history = createBrowserHistory()

const rootReducer = combineReducers({
    auth,
    spinner,
    notification,
    containers,
    task,
    requests,
    router: routerReducer
})

const RouterMiddleware = routerMiddleware(history)

const store = createStore(rootReducer, applyMiddleware(RouterMiddleware, ThunkMiddleware, LoggerMiddleware))

export {
    history,
    store
}