import { createReducer } from '../utils/reducer'

const initialState = {
    isVisible: false,
    message: null
}

/**
 * 
 * @param {*} state 
 * @param {*} action 
 */
const showNotification = () => {
    return true
}

/**
 * 
 * @param {*} state 
 * @param {*} action 
 */
const hideNotification = () => {
    return false
}

/**
 * 
 */
const notificationVisibilityReducer = createReducer(false, {
    'LOGIN_FAILURE': showNotification,
    'CHECK_TOKEN_FAILURE': hideNotification,
    'HIDE_NOTIFICATION': hideNotification,
    'REQUEST_KO': showNotification
})

/**
 * 
 * @param {*} message 
 * @param {*} action 
 */
const setNotificationMessage = (message, action) => {
    if (action.type === 'LOGIN_FAILURE') {
        return 'Fallo al autenticar el usuario'
    }

    if (action.type === 'HIDE_NOTIFICATION' || action.type === 'CHECK_TOKEN_FAILURE') {
        return null
    }

    if (action.type === 'REQUEST_KO' && action.payload !== 401) {
        return 'No se pudo procesar su petición, intente nuevamente'
    }

    return null
}

/**
 * 
 */
const notificationMessageReducer = createReducer(null, {
    'LOGIN_FAILURE': setNotificationMessage,
    'CHECK_TOKEN_FAILURE': setNotificationMessage,
    'HIDE_NOTIFICATION': setNotificationMessage,
    'REQUEST_KO': setNotificationMessage
})

/**
 * 
 * @param {*} state 
 * @param {*} action 
 */
export const notification = (state = initialState, action) => {
    return {
        isVisible: notificationVisibilityReducer(state.isVisible, action),
        message: notificationMessageReducer(state.message, action)
    }
}